unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, BasedCalendar, PlaningCalendar, Plan, PlaningDay, PlaningWorkgroup,
  StdCtrls, Buttons, ExtCtrls, ComCtrls, Spin;

type
  TFrmMain = class(TForm)
    Panel1: TPanel;
    PageCtrl: TPageControl;
    TsMonth: TTabSheet;
    TsWeek: TTabSheet;
    TsDaily: TTabSheet;
    TsWorkGrp: TTabSheet;
    RGRPAppointmentBooks: TRadioGroup;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Panel3: TPanel;
    BtnBirthdays: TBitBtn;
    BtnAppointments: TBitBtn;
    BtnFreeDays: TBitBtn;
    BtnOfficeHours: TBitBtn;
    PlaningCalendar: TPlaningCalendar;
    PlaningDayAsWeek: TPlaningDay;
    PlaningDay: TPlaningDay;
    PlaningWorkgroup: TPlaningWorkgroup;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    CmbTimeInterval: TComboBox;
    Label6: TLabel;
    EditYear: TEdit;
    EditMonth: TEdit;
    EditDay: TEdit;
    SpinYear: TSpinButton;
    SpinMonth: TSpinButton;
    SpinButton2: TSpinButton;
    PlanSimone: TPlan;
    PlanSoernt: TPlan;
    PlanPeter: TPlan;
    PlanKathe: TPlan;
    procedure FormCreate(Sender: TObject);
    procedure RGRPAppointmentBooksClick(Sender: TObject);
    procedure PlaningWorkgroupClick(Sender: TObject);
    procedure CmbTimeIntervalChange(Sender: TObject);
    procedure SpinYearUpClick(Sender: TObject);
    procedure SpinYearDownClick(Sender: TObject);
    procedure SpinMonthDownClick(Sender: TObject);
    procedure SpinMonthUpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure PlaningCalendarChange(Sender: TObject);
    procedure PlaningDayAsWeekChange(Sender: TObject);
    procedure BtnBirthdaysClick(Sender: TObject);
    procedure BtnAppointmentsClick(Sender: TObject);
    procedure BtnFreeDaysClick(Sender: TObject);
    procedure BtnOfficeHoursClick(Sender: TObject);
private
   procedure Init;
   procedure AddSomeData;

   function  GetActivePlan: TPlan;
   procedure SetActivePlan(aPlan: TPlan);
   procedure InitTimeInterval;
   procedure AssignSelTimeInterval;
   procedure RepaintCurrentControl;

   function  GetUserDate: TDateTime;
   procedure SetUserDate(aDate: TDateTime);
   procedure SetNewDate;

   procedure DoEditBirthdaysBlockingDays(bBirthday: Boolean);
   procedure DoEditAppointments;
   procedure DoEditOfficeHours;
public
end;

var
  FrmMain: TFrmMain;
{******************************************************************************}
implementation
Uses PlanTypes      ,
     Utils          ,
     TimePeriod     ,
     Day            ,
     AppointmentView,
     WeekBlockView  ,
     DayBlockView   ;


{$R *.DFM}
{******************************************************************************}
{* None Event Handlers                                                        *}
{******************************************************************************}
procedure TFrmMain.Init;
begin
   PageCtrl.ActivePage := TSMonth;
   InitTimeInterval;
   SetUserDate(Date);
   SetNewDate;
   AddSomeData;
   SetActivePlan(PlanSoernt);
end;
{******************************************************************************}
procedure TFrmMain.AddSomeData;

  procedure AddWDB(aPlan: TPlan; aItem: TTimePeriod; nDay: integer);
  begin
     aPlan.WeekDayBlockings[nDay].Add(TTimePeriod.CreateWithObj(aItem));
  end;

  procedure AddDB(aItem: TDay);
  begin
     PlanSimone.DayBlockings.Add(TDay.CreateWithObj(aItem));
     PlanSoernt.DayBlockings.Add(TDay.CreateWithObj(aItem));
     PlanPeter .DayBlockings.Add(TDay.CreateWithObj(aItem));
     PlanKathe .DayBlockings.Add(TDay.CreateWithObj(aItem));
     aItem.Free;
  end;

var
  nCounter    : integer    ;
  aMorningItem: TTimePeriod;
  aLunchItem  : TTimePeriod;
  aEveningItem: TTimePeriod;
begin

   aMorningItem := TTimePeriod.CreateWithParam(EncodeTime( 0, 0, 0, 0), EncodeTime( 8,30, 0, 0), NIL, 'Spare time');
   aLunchItem   := TTimePeriod.CreateWithParam(EncodeTime(13,30, 0, 0), EncodeTime(15, 0, 0, 0), NIL, 'Lunch'     );
   aEveningItem := TTimePeriod.CreateWithParam(EncodeTime(18,30, 0, 0), EncodeTime(23,59,59, 0), NIL, 'Spare time');

   for nCounter := 2 to 6 do begin
      AddWDB(PlanSoernt, aMorningItem, nCounter);
      AddWDB(PlanSoernt, aLunchItem  , nCounter);
      AddWDB(PlanSoernt, aEveningItem, nCounter);

      AddWDB(PlanPeter, aMorningItem, nCounter);
      AddWDB(PlanPeter, aLunchItem  , nCounter);
      AddWDB(PlanPeter, aEveningItem, nCounter);
   end;

   aMorningItem.Free;
   aLunchItem  .Free;
   aEveningItem.Free;

   aMorningItem := TTimePeriod.CreateWithParam(EncodeTime( 0, 0, 0, 0), EncodeTime( 6,30, 0, 0), NIL, 'Spare time');
   aLunchItem   := TTimePeriod.CreateWithParam(EncodeTime(11,30, 0, 0), EncodeTime(13, 0, 0, 0), NIL, 'Lunch'     );
   aEveningItem := TTimePeriod.CreateWithParam(EncodeTime(16,30, 0, 0), EncodeTime(23,59,59, 0), NIL, 'Spare time');

   for nCounter := 2 to 6 do begin
      AddWDB(PlanKathe , aMorningItem, nCounter);
      AddWDB(PlanKathe , aLunchItem  , nCounter);
      AddWDB(PlanKathe , aEveningItem, nCounter);

      AddWDB(PlanSimone, aMorningItem, nCounter);
      AddWDB(PlanSimone, aLunchItem  , nCounter);
      AddWDB(PlanSimone, aEveningItem, nCounter);
   end;

   aMorningItem.Free;
   aLunchItem  .Free;
   aEveningItem.Free;

   aMorningItem:= TTimePeriod.CreateWithParam(EncodeTime( 0, 0, 0, 0), EncodeTime( 23,59,59, 0), NIL, 'Spare time');
   AddWDB(PlanSoernt, aMorningItem, 1);
   AddWDB(PlanSoernt, aMorningItem, 7);
   AddWDB(PlanPeter , aMorningItem, 1);
   AddWDB(PlanPeter , aMorningItem, 7);

   AddWDB(PlanKathe , aMorningItem, 1);
   AddWDB(PlanKathe , aMorningItem, 7);
   AddWDB(PlanSimone, aMorningItem, 1);
   AddWDB(PlanSimone, aMorningItem, 7);
   aMorningItem.Free;

   AddDB(TDay.CreateWithParam(EncodeDate(1997,  1,  1), 'New Years Day' , NIL));
   AddDB(TDay.CreateWithParam(EncodeDate(1997,  7,  4), 'Independence Day', NIL));
   AddDB(TDay.CreateWithParam(EncodeDate(1997, 12, 25), '1. Chrismas day' , NIL));
   AddDB(TDay.CreateWithParam(EncodeDate(1997, 12, 26), '2. Chrismas day' , NIL));

   PlanSoernt.Appointments.AddWithParam(Date+EncodeTime(10,0,0,0), Date+EncodeTime(15,0,0,0), nil, 'Meeting with P. Andersen');
end;
{******************************************************************************}
function TFrmMain.GetActivePlan: TPlan;
begin
   Case RGRPAppointmentBooks.ItemIndex of
      0: Result := PlanSimone;
      1: Result := PlanSoernt;
      2: Result := PlanPeter;
      else
         Result := PlanKathe;
   end;
end;
{******************************************************************************}
procedure TFrmMain.SetActivePlan(aPlan: TPlan);
begin
   if( aPlan = PlanSimone) then RGRPAppointmentBooks.ItemIndex := 0;
   if( aPlan = PlanSoernt) then RGRPAppointmentBooks.ItemIndex := 1;
   if( aPlan = PlanPeter ) then RGRPAppointmentBooks.ItemIndex := 2;
   if( aPlan = PlanKathe ) then RGRPAppointmentBooks.ItemIndex := 3;
   PlaningCalendar.Plan        := aPlan;
   PlaningDayAsWeek.Plan       := aPlan;
   PlaningDay.Plan             := aPlan;
   PlaningWorkGroup.ActivePlan := aPlan;
end;
{******************************************************************************}
procedure TFrmMain.InitTimeInterval;
begin
   with CmbTimeInterval do begin
      Items.Add(' 5 Min');
      Items.Add('10 Min');
      Items.Add('15 Min');
      Items.Add('20 Min');
      Items.Add('30 Min');
      Items.Add('60 Min');
      ItemIndex := 5;
      AssignSelTimeInterval;
   end;
end;
{******************************************************************************}
procedure TFrmMain.AssignSelTimeInterval;
const
   TimeValues : array[0..5] of TTimeInterval =(ti05Min, ti10Min, ti15Min, ti20Min, ti30Min, ti60Min);
begin
   PlaningDayAsWeek.TimeInterval := TimeValues[CmbTimeInterval.ItemIndex];
   PlaningDay.TimeInterval       := TimeValues[CmbTimeInterval.ItemIndex];
   PlaningWorkGroup.TimeInterval := TimeValues[CmbTimeInterval.ItemIndex];
end;
{******************************************************************************}
procedure  TFrmMain.RepaintCurrentControl;
begin
   if(PageCtrl.ActivePage = TsMonth) then begin
      PlaningCalendar.Invalidate;
      PlaningCalendar.Update;
   end;

   if(PageCtrl.ActivePage = TsWeek) then begin
      PlaningDayAsWeek.Invalidate;
      PlaningDayAsWeek.Update;
   end;

   if(PageCtrl.ActivePage = TsDaily) then begin
      PlaningDay.Invalidate;
      PlaningDay.Update;
   end;

   if(PageCtrl.ActivePage = TsWorkGrp) then begin
      PlaningWorkgroup.Invalidate;
      PlaningWorkgroup.Update;
   end;
end;
{******************************************************************************}
function TFrmMain.GetUserDate: TDateTime;
begin
   Result := StrToDate(EditDay.Text + '.' + EditMonth.Text + '.' + EditYear.Text);
end;
{******************************************************************************}
procedure TFrmMain.SetUserDate(aDate: TDateTime);
begin
   with DateRec(aDate) do begin
      EditYear.Text  := IntToStr(wYear );
      EditMonth.Text := IntToStr(wMonth);
      EditDay.Text   := IntToStr(wDay  );
   end;
end;
{******************************************************************************}
procedure TFrmMain.SetNewDate;
const
  CorrectionDays : array[1..7] of integer = (-6, 0, -1, -2, -3, -4, -5);// Monday should allways be the first day
var
  aDate: TDateTime;
begin
   aDate := GetUserDate;
   if( Trunc(PlaningCalendar.Date) <>  aDate) then
      PlaningCalendar.Date:= aDate;

   if(Trunc(PlaningDayAsWeek.Date) <> aDate) then begin
      PlaningDayAsWeek.FirstDay := aDate + CorrectionDays[DayOfWeek(aDate)];
      PlaningDayAsWeek.ScrollToDateTime(aDate);
   end;

   if(Trunc(PlaningDay.FirstDay) <>  aDate) then begin
      PlaningDay.FirstDay := aDate;
      PlaningDay.ScrollToDateTime(aDate);
   end;

   if(Trunc(PlaningWorkGroup.FirstDay) <>  aDate) then
      PlaningWorkGroup.FirstDay := aDate;

end;
{******************************************************************************}
procedure TFrmMain.DoEditBirthdaysBlockingDays(bBirthday: Boolean);

   function EditDays(aList: TDayList): Boolean;
   begin
      try
         FrmDayBlockDlg:=TFrmDayBlockDlg.Create(NIL);
         try
            Result:= FrmDayBlockDlg.Execute(aList);
         finally
            FrmDayBlockDlg.Free;
         end;
      except
         on E:Exception do begin
            Result := FALSE;
            MessageDlg('Error creating dialog.'+#13+#10+E.Message, mtError, [mbOk] ,0);
         end;
      end;
   end;
   {******************}

var
  aTmpList: TDayList;
begin
   try
     aTmpList :=TDayList.Create;
     if(bBirthday) then
        aTmpList.Assign(GetActivePlan.Birthdays)
     else
        aTmpList.Assign(GetActivePlan.DayBlockings);

     try
        if EditDays(aTmpList) then begin
          if(bBirthday) then
             GetActivePlan.Birthdays.Assign(aTmpList)
          else
             GetActivePlan.DayBlockings.Assign(aTmpList);

          RepaintCurrentControl;
        end;
     finally
        aTmpList.Free;
     end;
  except
     on E:Exception do
       MessageDlg('Error creating temporary TDayList.'+#13+#10+E.Message, mtError, [mbOk], 0);
  end;
end;
{******************************************************************************}
procedure TFrmMain.DoEditAppointments;

   function DoAppointmentDlg(aList: TTimePeriodList): Boolean;
   begin
      try
         FrmPropAppointListDlg:=TFrmPropAppointListDlg.Create(Self);
         try
            Result:= FrmPropAppointListDlg.Execute(aList);
         finally
            FrmPropAppointListDlg.Free;
         end;
      except
         on E:Exception do begin
            Result := FALSE;
            MessageDlg('Error creating dialog.'+#13+#10+E.Message, mtError, [mbOk] ,0);
         end;
      end;
   end;
   {**************}
var
  aTmpList: TTimePeriodList;
begin
   try
     aTmpList := TTimePeriodList.Create;
     aTmpList.Assign(GetActivePlan.Appointments);
     try
        if DoAppointmentDlg(aTmpList) then begin
          GetActivePlan.Appointments.Assign(aTmpList);
          RepaintCurrentControl;
        end;
     finally
        aTmpList.Free;
     end;
  except
     on E:Exception do
       MessageDlg('Error creating temporary TTimePeriodList.'+#13+#10+E.Message, mtError, [mbOk], 0);
  end;
end;
{******************************************************************************}
procedure TFrmMain.DoEditOfficeHours;

   function DoBlockWeekView(aList: TBlockWeekPeriod): Boolean;
   begin
      try
         FrmBlockWeekView := TFrmBlockWeekView.Create(NIL);
         try
            Result:= FrmBlockWeekView.Execute(aList);
         finally
            FrmBlockWeekView.Free;
         end;
      except
         on E:Exception do begin
            Result := FALSE;
            MessageDlg('Error creating dialog.'+#13+#10+E.Message, mtError, [mbOk] ,0);
         end;
      end;
   end;
   {**************}

var
  aTmpList: TBlockWeekPeriod;
begin
   try
     aTmpList := TBlockWeekPeriod.Create;
     aTmpList.Assign(GetActivePlan.WeekDayBlockings);
     try
        if DoBlockWeekView(aTmpList) then begin
          GetActivePlan.WeekDayBlockings.Assign(aTmpList);
          RepaintCurrentControl;
        end;
     finally
        aTmpList.Free;
     end;
  except
     on E:Exception do
       MessageDlg('Error creating temporary TBlockWeePeriod.'+#13+#10+E.Message, mtError, [mbOk], 0);
  end;
end;
{******************************************************************************}
{******************************************************************************}
{* Event Handlers                                                             *}
{******************************************************************************}
procedure TFrmMain.FormCreate(Sender: TObject);
begin
   Init;
end;
{******************************************************************************}
procedure TFrmMain.RGRPAppointmentBooksClick(Sender: TObject);
begin
   SetActivePlan(GetActivePlan);
end;
{******************************************************************************}
procedure TFrmMain.PlaningWorkgroupClick(Sender: TObject);
begin
   if(PlaningWorkgroup.ActivePlan <> GetActivePlan) then
      SetActivePlan(PlaningWorkgroup.ActivePlan);
end;
{******************************************************************************}
procedure TFrmMain.CmbTimeIntervalChange(Sender: TObject);
begin
   AssignSelTimeInterval;
end;
{******************************************************************************}
procedure TFrmMain.SpinYearUpClick(Sender: TObject);
begin
   with DateRec(GetUserDate) do
      SetUserDate( EncodeDate(wYear+1 , wMonth, wDay));
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.SpinYearDownClick(Sender: TObject);
begin
   with DateRec(GetUserDate) do
      SetUserDate( EncodeDate(wYear-1 , wMonth, wDay));
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.SpinMonthDownClick(Sender: TObject);
var
  aDate: TDateTime;
begin
   aDate := GetUserDate;
   with DateRec(aDate) do
      SetUserDate( aDate - DIMonth(wMonth, wYear) );
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.SpinMonthUpClick(Sender: TObject);
var
  aDate: TDateTime;
begin
   aDate := GetUserDate;
   with DateRec(aDate) do
      SetUserDate( aDate + DIMonth(wMonth, wYear) );
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.SpinButton2DownClick(Sender: TObject);
begin
   SetUserDate( GetUserDate - 1);
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.SpinButton2UpClick(Sender: TObject);
begin
   SetUserDate( GetUserDate + 1);
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.PlaningCalendarChange(Sender: TObject);
begin
   SetUserDate(PlaningCalendar.Date);
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.PlaningDayAsWeekChange(Sender: TObject);
begin
   SetUserDate(PlaningDayAsWeek.Date);
   SetNewDate;
end;
{******************************************************************************}
procedure TFrmMain.BtnBirthdaysClick(Sender: TObject);
begin
   DoEditBirthdaysBlockingDays(TRUE);
end;
{******************************************************************************}
procedure TFrmMain.BtnAppointmentsClick(Sender: TObject);
begin
   DoEditAppointments;
end;
{******************************************************************************}
procedure TFrmMain.BtnFreeDaysClick(Sender: TObject);
begin
   DoEditBirthdaysBlockingDays(FALSE);
end;
{******************************************************************************}
procedure TFrmMain.BtnOfficeHoursClick(Sender: TObject);
begin
   DoEditOfficeHours;
end;
{******************************************************************************}
end.
